;====================================
;     SESSION TITLER Version 0.01
;  for OS/2 v2.x Virtual DOS Machine

;  Copyright (c) 1992, 1994, by Altair
;	  All rights reserved
;====================================
ID2Fh		equ	0CEh		;ID of this program to handle int 2Fh
stderr		equ	2		;Handle to standard error device

code		segment para
		org	0
TSR_Top		label	near
		org	2Ch
EnvironSeg	dw	?
		org	80h
ParamSize	db	?
parameter	label	byte
		org	0F7h
InstalledFlag	db	?
int21h_original dd	?
int2Fh_original dd	?

		assume	cs:code
NameTask:	jmp	transient
id		db	ID2Fh
		even
SetSessionFlag	dw	0
;===========================================================================
; Int 2Fh Trap
;---------------------------------------------------------------------------
; Function 00h: INSTLATION CHECK
;		 Entry:	 AH = ID2Fh (equated on top of this program)
;			 AL = 00h
;		 Return: AL = 0FFh if installed
;
; Function 01h: SET SESSION TITLE
;		 Entry:	 AH = ID2Fh (equated on top of this program)
;			 AL = 01h
;			 ES:DI -> new ASCIZ title or "" to restore original
;===========================================================================
int2Fh_entry:	pushf
		cmp	ah,id
		je	MyInt2Fh
		popf
		jmp	int2Fh_original

MyInt2Fh:	popf
		or	al,al
		jz	MyInt2Fh00h
;--------------
; Function 01h
;--------------
		push	SetSessionFlag
		mov	SetSessionFlag,ax
		mov	ah,64h
		xor	bx,bx
		mov	cx,636Ch
		mov	dx,1
		int	21h
		pop	SetSessionFlag
		iret
;--------------
; Function 00h
;--------------
MyInt2Fh00h:	dec	al
		iret
;==============================================================================
; Int 21h Trap
;------------------------------------------------------------------------------
; Traped Function: OS/2 v2.0 Virtual DOS Machine - GET/SET TASK TITLE
;		    Entry: AH = 64h
;			   BX = 0000h
;			   CX = 636Ch
;			   DX = function
;				 0000h enable automatic title switch
;				       (This trap routine ignore this function
;					and do nothing)
;				 0001h set session title
;				       (This trap routine ignore this function
;					and do nothing)
;				 0002h get session title
;				       (This trap routine passes control to
;					original int 21h handler)
;			   ES:DI -> new ASCIZ title or "" to restore original
;==============================================================================
int21h_entry:	pushf
		cmp	ah,64h
		je	int21h_trap64h
_int21h_original:popf
		jmp	int21h_original

int21h_trap64h: cmp	SetSessionFlag,0
		jne	_int21h_original
		or	bx,bx
		jnz	_int21h_original
		cmp	cx,636Ch
		jne	_int21h_original
		cmp	dx,2
		jnl	_int21h_original
		popf				;Do nothing
		iret				;and return to caller
TSR_Size	equ	$-TSR_Top
;==================================================================
; Transient Code
;------------------------------------------------------------------
; Usage: NameTask/?
;	  Tell you how to use
;
;	 [LoadHigh]  NameTask  [Session_Title]
;	  Set session title.
;	  Restore original session title if specified no parameter
;==================================================================
_help		db	13,10,'    SESSION TITLER Version 0.01'
		db	13,10,' for OS/2 v2.x Virtual DOS Machine'
		db	13,10,'Copyright (c) 1992, 1994, by Altair'
		db	13,10,'       All rights reserved',13,10,10
		db	'Usage:',9,'[LoadHigh]  NameTask  [session_title]'
		db	13,10,9,'(Session title of up to 14 characters)'
		db	13,10,10
_help_size	equ	$-_help

_IllegalVer	db	'Error!!  This program is works only in OS/2 '
		db	'virtual DOS machine',13,10,10
_IllegalVer_size equ	$-_IllegalVer
;-----------------
; 1st Entry Point
;-----------------
		assume	ds:code
transient:	mov	ah,30h		;Get DOS Version
		int	21h
		mov	dx,offset _IllegalVer
		mov	cx,_IllegalVer_size
		cmp	al,20		;OS/2 v2.0 DOS session?
		jne	MessageAndQuit	;No...
;--------------------------------
; Get Parameter and interpret it
;--------------------------------
		mov	bl,ParamSize
		xor	bh,bh
		mov	di,offset parameter
		mov	byte ptr[di+bx],0
IgnoreLead:	mov	al,[di]
		cmp	al,' '		;Ignore leading space(s)
		jne	GetParameter
GetNextCharacter:inc	di
		jmp	IgnoreLead

GetParameter:	cmp	al,'/'
		jne	CheckInstall
;--------------
; Message Help
;--------------
		mov	dx,offset _help
		mov	cx,_help_size
MessageAndQuit: mov	ah,40h		;Write
		mov	bx,stderr
		int	21h
terminate:	mov	ax,4C00h	;Terminate
		int	21h
;------------------
; Instlation Check
;------------------
CheckInstall:	xor	al,al
		mov	ah,id
		int	2Fh
		inc	al			;AL= 0(=0FFh+1) if installed
		mov	InstalledFlag,al
		jz	SetSessionTitle
;------------
; Initialize
;------------
		mov	ax,3521h			;Get int 21h vector
		int	21h
		mov	word ptr int21h_original,bx
		mov	word ptr int21h_original+2,es
		mov	ax,2521h			;Set int 21h vector
		mov	dx,offset int21h_entry
		int	21h
		mov	ax,352Fh			;Get int 2Fh vector
		int	21h
		mov	word ptr int2Fh_original,bx
		mov	word ptr int2Fh_original+2,es
		mov	ax,252Fh			;Set int 2Fh vector
		mov	dx,offset int2Fh_entry
		int	21h
		mov	ah,49h			;Free environment space
		mov	es,EnvironSeg
		int	21h
;-------------------
; Set Session Title
;-------------------
SetSessionTitle:mov	al,1
		mov	ah,id
		push	cs
		pop	es
		assume	es:code			;ES:DI -> Session title(ASCIIZ)
		int	2Fh
;-------------------------
; Terminate Stay Resident
;-------------------------
		cmp	es:InstalledFlag,0
		je	terminate
		mov	ax,3100h		;Terminate and stay resident
		mov	dx,(TSR_Size+0Fh)/10h
		int	21h
code		ends
		end	NameTask
